--[[----------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2015 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

----------------------------------------------------------------------------]]--

	-- WF.core.models
local WFModelsUtils = require 'WFModelsUtils'

	-- WF.lrmobile
local LriSyncStatusModel = require "LriSyncStatusModel"
local LriAlbumModel = require "LriAlbumModel"
local LriAllPhotosAlbumModel = require 'LriAllPhotosAlbumModel'

local LrmSocialActivityFeedModel = require 'LrmSocialActivityFeedModel'
local LrmSocialActivityStatusModel = require 'LrmSocialActivityStatusModel'

local LrmLibraryModelUtils = require 'LrmLibraryModelUtils'

--==============================================================================

local LriLibraryModelFactory = {}

local makeSubmodelFactoryFn = LrmLibraryModelUtils.makeSubmodelFactoryFn

--------------------------------------------------------------------------------

local function makeSubmodels()

	local LrmLibraryModel = {}
	
	LrmLibraryModel.albumModel = makeSubmodelFactoryFn( LriAlbumModel.albumModel )
	LrmLibraryModel.allPhotosAlbumModel = makeSubmodelFactoryFn( LriAllPhotosAlbumModel.makeModel )
	
	LrmLibraryModel.socialActivityFeedModel = makeSubmodelFactoryFn( LrmSocialActivityFeedModel.makeSocialActivityModel )
	LrmLibraryModel.makeSocialActivityStatusModel = makeSubmodelFactoryFn( LrmSocialActivityStatusModel.makeSocialActivityStatusModel )
	
	LrmLibraryModel.syncStatusModel = makeSubmodelFactoryFn( LriSyncStatusModel.makeModel )

	return LrmLibraryModel
	
end

--------------------------------------------------------------------------------

function LriLibraryModelFactory.makeLibrarySubModels()

	local subModels = {}
	
	return WFModelsUtils.aggregateModels( subModels, 
	
		makeSubmodels(),
		require 'LrmLibrarySocialModelImp',
		require 'LrmLibraryAlbumModelImp',
		require 'LrmLibraryAlbumListModelImp',
		require 'LrmLibraryRenditionModelImp',
		require 'LriLibraryReviewModelImp',
		require 'LrmLibraryAlbumAssetModelImp',
		require 'LrmLibraryAssetOrganizationModelImp',
		require 'LrmLibraryImportViaCopyModelImp',
		require 'LriLibraryStateModelImp',
		require 'LrmLibraryImportViaReferencesModelImp',
		require 'LriLibraryDatabaseModelImp',
		require 'LrmLibraryCacheModelImp',
		require 'LrmLibraryDelete',
		require 'LrmLibraryAlbumStatusModelImp',
		require 'LrmSearchModelImp'
	)
	
end

--------------------------------------------------------------------------------

return LriLibraryModelFactory
